#-*- mode: python; mode: fold -*-
from Globals import InitializeClass
##from Products.CPSSchemas.Widget import CPSWidgetType
from Products.CPSSchemas.BasicWidgets import CPSStringWidget, CPSEmailWidget
from Products.CPSSchemas.ExtendedWidgets import CPSDateTimeWidget
from Products.CPSSchemas.Widget import widgetRegistry
##from Products.CPSSchemas.WidgetTypesTool import WidgetTypeRegistry
from DateTime.DateTime import DateTime
from AccessControl import getSecurityManager

from re import compile

from zLOG import LOG, DEBUG

class StudentIdWidget(CPSStringWidget): ###(
    """ StudentId Widget"""
    meta_type = "StudentId Widget"
    digits = 8
    digits_str = "N"*digits
    letters = 2
    letters_str = "L"*letters
    
    def validate(self, datastructure, **kw):
        """Validate datastructure and update datamodel."""
        
        valid = CPSStringWidget.validate(self, datastructure, **kw)
        if not valid:
            return 0
        else:
            widget_id = self.getWidgetId()
            value = datastructure[widget_id]
            err = 0
            if not (len(value) == self.digits + self.letters and value[:self.digits].isdigit() and value[self.digits:].isalpha()):
                err = 'invalid Student Id in the format: %s%s with N = Number, L = Letter' % (self.digits_str,self.letters_str) 
            if err:
                datastructure.setError(widget_id, err)
            else:
                datamodel = datastructure.getDataModel()
                datamodel[self.fields[0]] = value
            
            return not err

InitializeClass(StudentIdWidget)

widgetRegistry.register(StudentIdWidget)

##Class StudentIdWidgetType(CPSWidgetType):
##    """Student Id String widget type."""
##    meta_type = "StudentId  Widget Type"
##    cls = StudentIdWidget

###)

class ScratchcardPinWidget(CPSStringWidget): ###(
    """ ScratchcardPin Widget"""
    meta_type = "Scratchcard Pin Widget"
    valid_pins = ['12345678',
                  '23456789',
                  '34567890',
                  '45678901',
                  ]
    
    def validate(self, datastructure, **kw):
        """Validate datastructure and update datamodel."""
        
        valid = CPSStringWidget.validate(self, datastructure, **kw)
        if not valid:
            return 0
        else:
            widget_id = self.getWidgetId()
            value = datastructure[widget_id]
            err = 0
            #import pdb; pdb.set_trace()
            if not value in self.valid_pins: 
                err = 'invalid Pin'
            if err:
                datastructure.setError(widget_id, err)
            else:
                datamodel = datastructure.getDataModel()
                datamodel[self.fields[0]] = value
            return not err

InitializeClass(ScratchcardPinWidget)
widgetRegistry.register(ScratchcardPinWidget)


###)

###########

